#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
#-----------------------------------------------------------------------------
Name		:	gdb
Version		:	14.1
Release		:	17.2.0.rel%{?dist}
Summary		:	A GNU source-level debugger for C, C++, Java and other languages
Group		:	Application/libraries

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	GPLv3+
URL		:	https://ftp.gnu.org/gnu/

Source0		:	%{name}-%{version}.tar.xz

#-----------------------------------------------------------------------------
BuildRequires	:	autoconf
BuildRequires	:	doxygen
BuildRequires	:	gcc-c++
BuildRequires	:	guile-devel

#-----------------------------------------------------------------------------
%description
GDB, the GNU debugger, allows you to debug programs written in C, C++,
Java, and other languages, by executing them in a controlled fashion
and printing their data.

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%doc COPYING README
%{_bindir}/gcore
%{_bindir}/%{name}*
%{_includedir}/%{name}/*.h
%{_infodir}/annotate.info.gz
%{_infodir}/stabs.info.gz
%{_infodir}/%{name}.info.gz
%{_infodir}/%{name}.info-[1-8].gz
%{_datadir}/%{name}/python/%{name}/*.py
%{_datadir}/%{name}/python/%{name}/command/*.py
%{_datadir}/%{name}/python/%{name}/function/*.py
%{_datadir}/%{name}/python/%{name}/printer/*.py
%{_datadir}/%{name}/syscalls/%{name}-syscalls.dtd
%{_datadir}/%{name}/syscalls/*.xml
%{_datadir}/%{name}/system-gdbinit/*.py
%{_datadir}/%{name}/guile/gdb.go
%{_datadir}/%{name}/guile/gdb.scm
%{_datadir}/%{name}/guile/%{name}/*.go
%{_datadir}/%{name}/guile/%{name}/*.scm
%{_datadir}/%{name}/python/%{name}/dap/*.py
%{_datadir}/info/%{name}.info-9.gz
%{_mandir}/man1/gcore.1.gz
%{_mandir}/man1/%{name}*.1.gz
%{_mandir}/man5/%{name}init.5.gz

#=============================================================================
%package	doc
Summary		:	A GNU source-level debugger GDB documentation

#-----------------------------------------------------------------------------
BuildArch	:	noarch
Requires	:	%{name}
#-----------------------------------------------------------------------------
%description	doc
'%{name}' debugger, all documentation

#-----------------------------------------------------------------------------
%files		doc
%defattr(-,root,root,-)
%{_defaultdocdir}/%{name}-%{version}/doxy/index.html
%{_defaultdocdir}/%{name}-%{version}/doxy/xml/*.xml
%{_defaultdocdir}/%{name}-%{version}/doxy/xml/*.{xslt,xsd}
%{_defaultdocdir}/%{name}-%{version}/doxy/gdb-api/*.{html,js,png,svg}
%{_defaultdocdir}/%{name}-%{version}/doxy/gdb-api/tabs.css
%{_defaultdocdir}/%{name}-%{version}/doxy/gdb-api/doxygen.css
%{_defaultdocdir}/%{name}-%{version}/doxy/gdb-api/navtree.css
%{_defaultdocdir}/%{name}-%{version}/doxy/gdb-api/search/*.{html,js,png,svg}
%{_defaultdocdir}/%{name}-%{version}/doxy/gdb-api/search/search.css
%{_defaultdocdir}/%{name}-%{version}/doxy/gdbserver/tabs.css
%{_defaultdocdir}/%{name}-%{version}/doxy/gdbserver/doxygen.css
%{_defaultdocdir}/%{name}-%{version}/doxy/gdbserver/navtree.css
%{_defaultdocdir}/%{name}-%{version}/doxy/gdbserver/*.{html,js,png,svg}
%{_defaultdocdir}/%{name}-%{version}/doxy/gdbserver/search/*.{html,js,png,svg}
%{_defaultdocdir}/%{name}-%{version}/doxy/gdbserver/search/search.css
%{_defaultdocdir}/%{name}-%{version}/doxy/gdb-xref/*.{html,js,png,svg}
%{_defaultdocdir}/%{name}-%{version}/doxy/gdb-xref/tabs.css
%{_defaultdocdir}/%{name}-%{version}/doxy/gdb-xref/doxygen.css
%{_defaultdocdir}/%{name}-%{version}/doxy/gdb-xref/navtree.css
%{_defaultdocdir}/%{name}-%{version}/doxy/gdb-xref/search/*.{html,js,png,svg}
%{_defaultdocdir}/%{name}-%{version}/doxy/gdb-xref/search/search.css

#=============================================================================
%prep
%setup -q

#First, apply a change from upstream to fix issues
#with readline-8.2 or later:
sed -i							\
  -e "/return/s/rl.*characters/(char *) &/"		\
  gdb/completer.c

#-----------------------------------------------------------------------------
#building application
%build

#autoconf -v -i -f
%{__mkdir_p} build
pushd build
../configure						\
        --prefix=%{_prefix}				\
        --includedir=%{_includedir}			\
        --sysconfdir=%{_sysconfdir}			\
	--exec-prefix=%{_exec_prefix}			\
        --sbindir=%{_sbindir}				\
	--mandir=%{_mandir}				\
	--libdir=%{_libdir}				\
	--infodir=%{_infodir}				\
	--sharedstatedir=%{_var}/lib			\
	--localstatedir=%{_var}				\
	--docdir=%{_defaultdocdir}/%{name}-%{version}	\
	--with-system-readline				\
	--with-python=/usr/bin/python3			\
	--with-guile					\


%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make}						\
	%{_smp_mflags}

#to build the API documentation using Doxygen-1.8.16
%{__make}						\
	-C %{name}/doc					\
	doxy
popd

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

pushd build
%{__make}						\
	-C %{name}					\
	DESTDIR=%{buildroot}				\
	install

#installing documentation
%{__mkdir_p}						\
	%{buildroot}%{_defaultdocdir}/%{name}-%{version}
%{__cp} -R						\
	%{name}/doc/doxy				\
	%{buildroot}%{_defaultdocdir}/%{name}-%{version}

#cleaning empty directory
%{__rm}  %{buildroot}/%{_datadir}/info/dir
popd

#-----------------------------------------------------------------------------
%changelog
